weka.gui.beans

## Class Filter

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - weka.gui.beans.Filter

- All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.util.EventListener, javax.accessibility.Accessible, BeanCommon, ConfigurationProducer, DataSource, DataSourceListener, EventConstraints, InstanceListener, TestSetListener, TestSetProducer, TrainingSetListener, TrainingSetProducer, UserRequestAcceptor, Visible, WekaWrapper

      public class Filter
      extends javax.swing.JPanel
      implements BeanCommon, Visible, WekaWrapper, java.io.Serializable, UserRequestAcceptor, TrainingSetListener, TestSetListener, TrainingSetProducer, TestSetProducer, DataSource, DataSourceListener, InstanceListener, EventConstraints, ConfigurationProducer

  A wrapper bean for Weka filters
  Version:
    $Revision: 10220 $
  Author:
    Mark Hall
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.BaselineResizeBehavior`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JComponent

      `TOOL_TIP_TEXT_KEY, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Filter()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `acceptDataSet(DataSetEvent e)` Accept a data set
    `void` | `acceptInstance(InstanceEvent e)` Accept an instance for processing by StreamableFilters only
    `void` | `acceptTestSet(TestSetEvent e)` Accept a test set
    `void` | `acceptTrainingSet(TrainingSetEvent e)` Accept a training set
    `void` | `addConfigurationListener(ConfigurationListener cl)` We don't have to keep track of configuration listeners (see the documentation for ConfigurationListener/ConfigurationEvent).
    `void` | `addDataSourceListener(DataSourceListener dsl)` Add a data source listener
    `void` | `addInstanceListener(InstanceListener tsl)` Add an instance listener
    `void` | `addTestSetListener(TestSetListener tsl)` Add a test set listener
    `void` | `addTrainingSetListener(TrainingSetListener tsl)` Add a training set listener
    `boolean` | `connectionAllowed(java.beans.EventSetDescriptor esd)` Returns true if, at this time, the object will accept a connection according to the supplied EventSetDescriptor
    `boolean` | `connectionAllowed(java.lang.String eventName)` Returns true if, at this time, the object will accept a connection with respect to the supplied event name
    `void` | `connectionNotification(java.lang.String eventName, java.lang.Object source)` Notify this object that it has been registered as a listener with a source with respect to the supplied event name
    `void` | `disconnectionNotification(java.lang.String eventName, java.lang.Object source)` Notify this object that it has been deregistered as a listener with a source with respect to the supplied event name
    `java.util.Enumeration<java.lang.String>` | `enumerateRequests()` Return an enumeration of user requests
    `boolean` | `eventGeneratable(java.lang.String eventName)` Returns true, if at the current time, the named event could be generated.
    `java.lang.String` | `getCustomName()` Get the custom (descriptive) name for this bean (if one has been set)
    `Filter` | `getFilter()`
    `BeanVisual` | `getVisual()` Get the visual appearance of this bean
    `java.lang.Object` | `getWrappedAlgorithm()` Get the filter wrapped by this bean
    `java.lang.String` | `globalInfo()` Global info (if it exists) for the wrapped filter
    `boolean` | `isBusy()` Returns true if.
    `void` | `performRequest(java.lang.String request)` Perform the named request
    `void` | `removeConfigurationListener(ConfigurationListener cl)` We don't have to keep track of configuration listeners (see the documentation for ConfigurationListener/ConfigurationEvent).
    `void` | `removeDataSourceListener(DataSourceListener dsl)` Remove a data source listener
    `void` | `removeInstanceListener(InstanceListener tsl)` Remove an instance listener
    `void` | `removeTestSetListener(TestSetListener tsl)` Remove a test set listener
    `void` | `removeTrainingSetListener(TrainingSetListener tsl)` Remove a training set listener
    `void` | `setCustomName(java.lang.String name)` Set a custom (descriptive) name for this bean
    `void` | `setFilter(Filter c)` Set the filter to be wrapped by this bean
    `void` | `setLog(Logger logger)` Set a logger
    `void` | `setVisual(BeanVisual newVisual)` Set the visual appearance of this bean
    `void` | `setWrappedAlgorithm(java.lang.Object algorithm)` Set the filter to be wrapped by this bean
    `void` | `stop()` Stop all action if possible
    `void` | `useDefaultVisual()` Use the default visual appearance

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintImmediately, paintImmediately, print, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, createImage, createImage, createVolatileImage, createVolatileImage, dispatchEvent, enable, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Filter

          public Filter()

  - ### Method Detail

    - #### globalInfo

          public java.lang.String globalInfo()

      Global info (if it exists) for the wrapped filter
      Returns:
        the global info

    - #### setCustomName

          public void setCustomName(java.lang.String name)

      Set a custom (descriptive) name for this bean
      Specified by:
        `setCustomName` in interface `BeanCommon`
      Parameters:
        `name` - the name to use

    - #### getCustomName

          public java.lang.String getCustomName()

      Get the custom (descriptive) name for this bean (if one has been set)
      Specified by:
        `getCustomName` in interface `BeanCommon`
      Returns:
        the custom name (or the default name)

    - #### setFilter

          public void setFilter(Filter c)

      Set the filter to be wrapped by this bean
      Parameters:
        `c` - a `weka.filters.Filter` value

    - #### getFilter

          public Filter getFilter()

    - #### setWrappedAlgorithm

          public void setWrappedAlgorithm(java.lang.Object algorithm)

      Set the filter to be wrapped by this bean
      Specified by:
        `setWrappedAlgorithm` in interface `WekaWrapper`
      Parameters:
        `algorithm` - a weka.filters.Filter
      Throws:
        `java.lang.IllegalArgumentException` - if an error occurs

    - #### getWrappedAlgorithm

          public java.lang.Object getWrappedAlgorithm()

      Get the filter wrapped by this bean
      Specified by:
        `getWrappedAlgorithm` in interface `WekaWrapper`
      Returns:
        an `Object` value

    - #### acceptTrainingSet

          public void acceptTrainingSet(TrainingSetEvent e)

      Accept a training set
      Specified by:
        `acceptTrainingSet` in interface `TrainingSetListener`
      Parameters:
        `e` - a `TrainingSetEvent` value

    - #### acceptInstance

          public void acceptInstance(InstanceEvent e)

      Accept an instance for processing by StreamableFilters only
      Specified by:
        `acceptInstance` in interface `InstanceListener`
      Parameters:
        `e` - an `InstanceEvent` value

    - #### acceptTestSet

          public void acceptTestSet(TestSetEvent e)

      Accept a test set
      Specified by:
        `acceptTestSet` in interface `TestSetListener`
      Parameters:
        `e` - a `TestSetEvent` value

    - #### acceptDataSet

          public void acceptDataSet(DataSetEvent e)

      Accept a data set
      Specified by:
        `acceptDataSet` in interface `DataSourceListener`
      Parameters:
        `e` - a `DataSetEvent` value

    - #### setVisual

          public void setVisual(BeanVisual newVisual)

      Set the visual appearance of this bean
      Specified by:
        `setVisual` in interface `Visible`
      Parameters:
        `newVisual` - a `BeanVisual` value

    - #### getVisual

          public BeanVisual getVisual()

      Get the visual appearance of this bean
      Specified by:
        `getVisual` in interface `Visible`
      Returns:
        a `BeanVisual` value

    - #### useDefaultVisual

          public void useDefaultVisual()

      Use the default visual appearance
      Specified by:
        `useDefaultVisual` in interface `Visible`

    - #### addTrainingSetListener

          public void addTrainingSetListener(TrainingSetListener tsl)

      Add a training set listener
      Specified by:
        `addTrainingSetListener` in interface `TrainingSetProducer`
      Parameters:
        `tsl` - a `TrainingSetListener` value

    - #### removeTrainingSetListener

          public void removeTrainingSetListener(TrainingSetListener tsl)

      Remove a training set listener
      Specified by:
        `removeTrainingSetListener` in interface `TrainingSetProducer`
      Parameters:
        `tsl` - a `TrainingSetListener` value

    - #### addTestSetListener

          public void addTestSetListener(TestSetListener tsl)

      Add a test set listener
      Specified by:
        `addTestSetListener` in interface `TestSetProducer`
      Parameters:
        `tsl` - a `TestSetListener` value

    - #### removeTestSetListener

          public void removeTestSetListener(TestSetListener tsl)

      Remove a test set listener
      Specified by:
        `removeTestSetListener` in interface `TestSetProducer`
      Parameters:
        `tsl` - a `TestSetListener` value

    - #### addDataSourceListener

          public void addDataSourceListener(DataSourceListener dsl)

      Add a data source listener
      Specified by:
        `addDataSourceListener` in interface `DataSource`
      Parameters:
        `dsl` - a `DataSourceListener` value

    - #### removeDataSourceListener

          public void removeDataSourceListener(DataSourceListener dsl)

      Remove a data source listener
      Specified by:
        `removeDataSourceListener` in interface `DataSource`
      Parameters:
        `dsl` - a `DataSourceListener` value

    - #### addInstanceListener

          public void addInstanceListener(InstanceListener tsl)

      Add an instance listener
      Specified by:
        `addInstanceListener` in interface `DataSource`
      Parameters:
        `tsl` - an `InstanceListener` value

    - #### removeInstanceListener

          public void removeInstanceListener(InstanceListener tsl)

      Remove an instance listener
      Specified by:
        `removeInstanceListener` in interface `DataSource`
      Parameters:
        `tsl` - an `InstanceListener` value

    - #### addConfigurationListener

          public void addConfigurationListener(ConfigurationListener cl)

      We don't have to keep track of configuration listeners (see the documentation for ConfigurationListener/ConfigurationEvent).
      Specified by:
        `addConfigurationListener` in interface `ConfigurationProducer`
      Parameters:
        `cl` - a ConfigurationListener.

    - #### removeConfigurationListener

          public void removeConfigurationListener(ConfigurationListener cl)

      We don't have to keep track of configuration listeners (see the documentation for ConfigurationListener/ConfigurationEvent).
      Specified by:
        `removeConfigurationListener` in interface `ConfigurationProducer`
      Parameters:
        `cl` - a ConfigurationListener.

    - #### connectionAllowed

          public boolean connectionAllowed(java.lang.String eventName)

      Returns true if, at this time, the object will accept a connection with respect to the supplied event name
      Specified by:
        `connectionAllowed` in interface `BeanCommon`
      Parameters:
        `eventName` - the event
      Returns:
        true if the object will accept a connection

    - #### connectionAllowed

          public boolean connectionAllowed(java.beans.EventSetDescriptor esd)

      Returns true if, at this time, the object will accept a connection according to the supplied EventSetDescriptor
      Specified by:
        `connectionAllowed` in interface `BeanCommon`
      Parameters:
        `esd` - the EventSetDescriptor
      Returns:
        true if the object will accept a connection

    - #### connectionNotification

          public void connectionNotification(java.lang.String eventName,
                                             java.lang.Object source)

      Notify this object that it has been registered as a listener with a source with respect to the supplied event name
      Specified by:
        `connectionNotification` in interface `BeanCommon`
      Parameters:
        `eventName` -
        `source` - the source with which this object has been registered as a listener

    - #### disconnectionNotification

          public void disconnectionNotification(java.lang.String eventName,
                                                java.lang.Object source)

      Notify this object that it has been deregistered as a listener with a source with respect to the supplied event name
      Specified by:
        `disconnectionNotification` in interface `BeanCommon`
      Parameters:
        `eventName` - the event
        `source` - the source with which this object has been registered as a listener

    - #### stop

          public void stop()

      Stop all action if possible
      Specified by:
        `stop` in interface `BeanCommon`

    - #### isBusy

          public boolean isBusy()

      Returns true if. at this time, the bean is busy with some (i.e. perhaps a worker thread is performing some calculation).
      Specified by:
        `isBusy` in interface `BeanCommon`
      Returns:
        true if the bean is busy.

    - #### setLog

          public void setLog(Logger logger)

      Set a logger
      Specified by:
        `setLog` in interface `BeanCommon`
      Parameters:
        `logger` - a `Logger` value

    - #### enumerateRequests

          public java.util.Enumeration<java.lang.String> enumerateRequests()

      Return an enumeration of user requests
      Specified by:
        `enumerateRequests` in interface `UserRequestAcceptor`
      Returns:
        an `Enumeration` value

    - #### performRequest

          public void performRequest(java.lang.String request)

      Perform the named request
      Specified by:
        `performRequest` in interface `UserRequestAcceptor`
      Parameters:
        `request` - a `String` value
      Throws:
        `java.lang.IllegalArgumentException` - if an error occurs

    - #### eventGeneratable

          public boolean eventGeneratable(java.lang.String eventName)

      Returns true, if at the current time, the named event could be generated. Assumes that supplied event names are names of events that could be generated by this bean.
      Specified by:
        `eventGeneratable` in interface `EventConstraints`
      Parameters:
        `eventName` - the name of the event in question
      Returns:
        true if the named event could be generated at this point in time